| Oyranos Colour Management System API

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
oyOptions_s Struct Reference
Values Handling

generic Options More...

`#include <oyOptions_s.h>`

Inheritance diagram for oyOptions_s:
Collaboration diagram for oyOptions_s:

## Public Member Functions
OYAPI oyOptions_s *OYEXPORT | oyOptions_New (oyObject_s object)
| allocate a new Options object More...
OYAPI oyOptions_s *OYEXPORT | oyOptions_Copy (oyOptions_s *options, oyObject_s object)
| copy or reference a Options object More...
OYAPI int OYEXPORT | oyOptions_Release (oyOptions_s **options)
| release and possibly deallocate a oyOptions_s object More...
OYAPI int OYEXPORT | oyOptions_MoveIn (oyOptions_s *list, oyOption_s **obj, int pos)
| add an element to a Options list More...
OYAPI int OYEXPORT | oyOptions_ReleaseAt (oyOptions_s *list, int pos)
| release a element from a Options list More...
OYAPI oyOption_s *OYEXPORT | oyOptions_Get (oyOptions_s *list, int pos)
| get a element of a Options list More...
OYAPI int OYEXPORT | oyOptions_Count (oyOptions_s *list)
| count the elements in a Options list More...
OYAPI int OYEXPORT | oyOptions_Clear (oyOptions_s *list)
| clear the elements in a Options list More...
OYAPI int OYEXPORT | oyOptions_Sort (oyOptions_s *list, int32_t *rank_list)
| sort a list according to a rank_list More...
oyOptions_s * | oyOptions_FromBoolean (oyOptions_s *set_a, oyOptions_s *set_b, oyBOOLEAN_e type, oyObject_s object)
| boolean operations on two sets of option More...
oyOptions_s * | oyOptions_FromText (const char *text, uint32_t flags, oyObject_s object)
| deserialise a text file to oyOptions_s data More...
int | oyOptions_Add (oyOptions_s *options, oyOption_s *option, int pos, oyObject_s object)
| add a element to a Options list More...
int | oyOptions_Set (oyOptions_s *options, oyOption_s *option, int pos, oyObject_s object)
| set a element in a Options list More...
int | oyOptions_SetOpts (oyOptions_s *list, oyOptions_s *add)
| set options in a Options list More...
int | oyOptions_AppendOpts (oyOptions_s *list, oyOptions_s *append)
| Basic reference options from one list into an other. More...
int | oyOptions_CopyFrom (oyOptions_s **list, oyOptions_s *from, oyBOOLEAN_e type, oyFILTER_REG_e fields, oyObject_s object)
| copy from one option set to an other option set More...
int | oyOptions_Filter (oyOptions_s **add_list, int32_t *count, uint32_t flags, oyBOOLEAN_e type, const char *registration, oyOptions_s *src_list)
| filter options More...
const char * | oyOptions_GetText (oyOptions_s *options, oyNAME_e type)
| dump options to text More...
int | oyOptions_CountType (oyOptions_s *options, const char *registration, oyOBJECT_e type)
| search for options with special attributes More...
oyOption_s * | oyOptions_Find (oyOptions_s *options, const char *registration)
| search for a certain option key More...
const char * | oyOptions_FindString (oyOptions_s *options, const char *registration, const char *value)
| search for a certain option key and possibly value More...
int | oyOptions_SetFromText (oyOptions_s **obj, const char *registration, const char *value, uint32_t flags)
| change a value More...
int | oyOptions_FindInt (oyOptions_s *options, const char *registration, int pos, int32_t *result)
| get a value More...
int | oyOptions_SetFromInt (oyOptions_s **obj, const char *registration, int32_t value, int pos, uint32_t flags)
| change a value More...
int | oyOptions_FindDouble (oyOptions_s *options, const char *registration, int pos, double *result)
| get a value More...
int | oyOptions_SetFromDouble (oyOptions_s **obj, const char *registration, double value, int pos, uint32_t flags)
| change a value More...
oyStruct_s * | oyOptions_GetType (oyOptions_s *options, int pos, const char *registration, oyOBJECT_e type)
| select from options with special attribute More...
int | oyOptions_MoveInStruct (oyOptions_s **obj, const char *registration, oyStruct_s **oy_struct, uint32_t flags)
| change a value More...
int | oyOptions_SetFromData (oyOptions_s **options, const char *registration, oyPointer ptr, size_t size, uint32_t flags)
| set a data blob or plain pointer More...
int | oyOptions_FindData (oyOptions_s *options, const char *registration, oyPointer *result, size_t *size, oyAlloc_f allocateFunc)
| get a value More...
int | oyOptions_SetSource (oyOptions_s *options, oyOPTIONSOURCE_e source)
| set source attribute More...
OYAPI int OYEXPORT | oyOptions_ObserverAdd (oyOptions_s *object, oyStruct_s *observer, oyStruct_s *user_data, oyObserver_Signal_f signalFunc)
| observe options and its elements More...
OYAPI int OYEXPORT | oyOptions_ObserversDisable (oyOptions_s *object)
| disable signaling More...
OYAPI int OYEXPORT | oyOptions_ObserversEnable (oyOptions_s *object)
| disable signaling More...
OYAPI int OYEXPORT | oyOptions_SetDriverContext (oyOptions_s **options, oyPointer driver_context, const char *driver_context_type, size_t driver_context_size, oyObject_s object)
| set a device option from a given external context More...
oyOptions_s * | oyOptions_ForFilter (const char *registration, const char *cmm, uint32_t flags, oyObject_s object)
| provide Oyranos behaviour settings More...
oyOptions_s * | oyOptions_ForFilter_ (oyFilterCore_s_ *filter, uint32_t flags, oyObject_s object)
| Provide Oyranos behaviour settings. More...
OYAPI int OYEXPORT | oyOptions_SaveToDB (oyOptions_s *options, const char *registration, char **new_reg, oyAlloc_f allocateFunc)
| store a oyOptions_s in DB More...
int | oyOptions_DoFilter (oyOptions_s *opts, uint32_t flags, const char *filter_type)
| filter the options More...
Public Member Functions inherited from oyStruct_s
const char * | oyStruct_GetText (oyStruct_s *obj, oyNAME_e name_type, uint32_t flags)
| get a text dump More...

## Data Fields
oyStruct_Copy_f | copy
oyStruct_Release_f | release
Data Fields inherited from oyStruct_s
oyStruct_Copy_f | copy
oyStruct_Release_f | release

## Detailed Description

generic Options

Options can be any flag or rendering intent and other informations needed to configure a process. The object contains a list of oyOption_s objects.

Note
  This class holds a list of objects [list]

Version
  Oyranos: x.x.x

Since
  YYYY/MM/DD (Oyranos: x.x.x)

Date
  YYYY/MM/DD

## Member Function Documentation

int oyOptions_Add | ( | oyOptions_s * | options,
|  | oyOption_s * | option,
|  | int | pos,
|  | oyObject_s | object
| ) |  |

add a element to a Options list

Function oyOptions_Add

We must not add any already listed option. (oyFILTER_REG_TOP)

Adding a new element without any checks is as simple as following code:

    *     tmp = oyOption_Copy( option, object );
    *     oyOptions_MoveIn( options, &tmp, -1 );

Version
  Oyranos: 0.1.9

Since
  2008/11/17 (Oyranos: 0.1.9)

Date
  2010/11/27

References oyFILTER_REG_TOP, oyOption_s::oyOption_Copy(), oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyOptions_MoveIn().

Referenced by oyConfigs_s::oyConfigs_FromDB(), oyOptions_DoFilter(), oyOptions_Filter(), and oyOptions_FromBoolean().

int oyOptions_AppendOpts | ( | oyOptions_s * | list,
|  | oyOptions_s * | append
| ) |  |

Basic reference options from one list into an other.

Function oyOptions_AppendOpts

See Also
  oyOptions_MoveIn

Version
  Oyranos:

Since

Date

References oyOptions_Count(), oyOptions_Get(), and oyOptions_MoveIn().

Referenced by oyConfig_s::oyConfig_Count(), oyConfig_s::oyConfig_Get(), oyConfig_s::oyConfig_SaveToDB(), and oyOptions_ForFilter_().

OYAPI int OYEXPORT oyOptions_Clear | ( | oyOptions_s * | list | ) |

clear the elements in a Options list

Function oyOptions_Clear

Parameters

  [in,out] | list | the list

Returns
  0 - success; otherwise - error

Version
  Oyranos: 0.3.0

Since
  2011/02/01 (Oyranos: 0.3.0)

Date
  2011/02/01

References oyOBJECT_OPTIONS_S, and oyStructList_s::oyStructList_Clear().

Referenced by oyConfig_s::oyConfig_GetOptions(), oyOptions_DoFilter(), and oyProfiles_s::oyProfiles_DeviceRank().

OYAPI oyOptions_s *OYEXPORT oyOptions_Copy | ( | oyOptions_s * | options,
|  | oyObject_s | object
| ) |  |

copy or reference a Options object

Function oyOptions_Copy

The function is for copying and for referencing. The reference is the most often used way, which saves resourcs and time.

Parameters

  [in] | options | Options struct object
  | object | NULL - means reference, the optional object triggers a real copy

References oyOBJECT_OPTIONS_S.

Referenced by oyConfig_s::oyConfig_GetFromDB(), oyConfigs_s::oyConfigs_FromDeviceClass(), oyFilterCore_s::oyFilterCore_NewWith(), oyFilterGraph_s::oyFilterGraph_GetOptions(), oyFilterNode_s::oyFilterNode_GetOptions(), oyFilterNode_s::oyFilterNode_GetTags(), oyImage_s::oyImage_GetTags(), oyImage_s::oyImage_SetCritical(), oyOptions_FromBoolean(), and oyPixelAccess_s::oyPixelAccess_GetRequestQueue().

int oyOptions_CopyFrom | ( | oyOptions_s ** | list,
|  | oyOptions_s * | from,
|  | oyBOOLEAN_e | type,
|  | oyFILTER_REG_e | fields,
|  | oyObject_s | object
| ) |  |

copy from one option set to an other option set

Function oyOptions_CopyFrom

Parameters

  [out] | list | target
  [in] | from | source
  | type | boolean operation before copy
  | fields | registration fields of each option
  | object | the optional object

Returns
  0 - success; 1 - error; -1 issue

Version
  Oyranos: 0.1.10

Since
  2009/05/05 (Oyranos: 0.1.10)

Date
  2009/10/25

References oyBOOLEAN_DIFFERENZ, oyBOOLEAN_INTERSECTION, oyBOOLEAN_SUBSTRACTION, oyBOOLEAN_UNION, oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), oyOptions_MoveIn(), oyOptions_New(), oyOptions_Release(), oyOptions_SetOpts(), oyStructList_s::oyStructList_New(), and oyStructList_s::oyStructList_Release().

Referenced by oyFilterPlug_s::oyFilterPlug_ResolveImage(), and oyImage_ToFile().

OYAPI int OYEXPORT oyOptions_Count | ( | oyOptions_s * | list | ) |

count the elements in a Options list

Function oyOptions_Count

Parameters

  [in,out] | list | the list

Returns
  element count

Version
  Oyranos: 0.1.10

Since
  2010/07/05 (Oyranos: 0.1.10)

Date
  2010/07/05

References oyOBJECT_OPTIONS_S, and oyStructList_s::oyStructList_Count().

Referenced by oyConfig_s::oyConfig_Compare(), oyConfig_s::oyConfig_Count(), oyDeviceGetInfo(), oyDeviceSetProfile(), oyOptions_Add(), oyOptions_AppendOpts(), oyOptions_CopyFrom(), oyOptions_CountType(), oyOptions_DoFilter(), oyOptions_Filter(), oyOptions_Find(), oyOptions_ForFilter_(), oyOptions_FromBoolean(), oyOptions_GetText(), oyOptions_GetType(), oyOptions_ObserversDisable(), oyOptions_ObserversEnable(), oyOptions_SaveToDB(), oyOptions_Set(), oyOptions_SetOpts(), oyOptions_SetSource(), and oyProfiles_s::oyProfiles_DeviceRank().

int oyOptions_CountType | ( | oyOptions_s * | options,
|  | const char * | registration,
|  | oyOBJECT_e | type
| ) |  |

search for options with special attributes

Function oyOptions_CountType

Version
  Oyranos: 0.1.10

Since
  2009/03/04 (Oyranos: 0.1.10)

Date
  2009/03/04

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyVAL_STRUCT.

int oyOptions_DoFilter | ( | oyOptions_s * | opts,
|  | uint32_t | flags,
|  | const char * | filter_type
| ) |  |

filter the options

Function oyOptions_DoFilter

The returned options are read in from the Elektra settings and if thats not available from the inbuild defaults. The later can explicitely selected with oyOPTIONSOURCE_FILTER passed as flags argument. advanced options can be filtered out by adding oyOPTIONATTRIBUTE_ADVANCED.

Modules should handle the advanced options as well but shall normally not act upon them. The convention to set them zero, keeps them inactive.

On the front end side the CMM cache has to include them, as they will influence the hash sum generation. The question arrises, whether to include these options marked as non visible along the path or require the CMM cache code to check each time for them on cache lookup. The oyOption_s::flags is already in place. So we use it and do inclusion. Front end options can be filtered as they do not affect the CMM cache.

See Also
  oyOptions_Add

Parameters

  | opts | the options
  [in] | flags | for inbuild defaults | oyOPTIONSOURCE_FILTER; for options marked as advanced | oyOPTIONATTRIBUTE_ADVANCED; for front end options | oyOPTIONATTRIBUTE_FRONT
  | filter_type | the type level from a registration

Returns
  options

Version
  Oyranos: 0.1.9

Since
  2008/11/27 (Oyranos: 0.1.9)

Date
  2008/11/27

References oyFILTER_REG_TYPE, oyNAME_DESCRIPTION, oyOption_s::oyOption_GetRegistration(), oyOption_s::oyOption_GetText(), oyOption_s::oyOption_Release(), oyOption_s::oyOption_SetFromText(), oyOPTIONATTRIBUTE_ADVANCED, oyOPTIONATTRIBUTE_EDIT, oyOPTIONATTRIBUTE_FRONT, oyOptions_Add(), oyOptions_Clear(), oyOptions_Count(), oyOptions_Get(), oyOptions_MoveIn(), oyOptions_New(), oyOptions_Release(), oyOPTIONSOURCE_FILTER, and oyOPTIONSOURCE_USER.

Referenced by oyOptions_ForFilter_().

int oyOptions_Filter | ( | oyOptions_s ** | add_list,
|  | int32_t * | count,
|  | uint32_t | flags,
|  | oyBOOLEAN_e | type,
|  | const char * | registration,
|  | oyOptions_s * | src_list
| ) |  |

filter options

Function oyOptions_Filter

Each option added to the add_list is a cheaply linked one.

See Also
  oyOptions_Add

Parameters

  [out] | add_list | the options list to add to
  [out] | count | the number of matching options
  [in] | flags | for inbuild defaults | oyOPTIONSOURCE_FILTER
  [in] | type | support are oyBOOLEAN_INTERSECTION and oyBOOLEAN_DIFFERENZ
  [in] | registration | a registration which shall be matched
  [in] | src_list | the options to select from

Returns
  0 - success; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/05/05 (Oyranos: 0.1.10)

Date
  2009/05/05

References oyBOOLEAN_DIFFERENZ, oyBOOLEAN_INTERSECTION, oyBOOLEAN_UNION, oyOBJECT_OPTIONS_S, oyOption_s::oyOption_Release(), oyOptions_Add(), oyOptions_Count(), oyOptions_Get(), oyOptions_New(), oyOPTIONSOURCE_DATA, oyOPTIONSOURCE_FILTER, and oyOPTIONSOURCE_USER.

Referenced by oyFilterNode_s::oyFilterNode_GetOptions(), oyFilterPlug_s::oyFilterPlug_ResolveImage(), and oyPixelAccess_s::oyPixelAccess_Create().

oyOption_s * oyOptions_Find | ( | oyOptions_s * | options,
|  | const char * | registration
| ) |  |

search for a certain option key

Function oyOptions_Find

This function returns the first found option for a given key. The key is represented by a registrations option level.

Parameters

  options | set of options
  registration | registration or key

Returns
  a matching options

Version
  Oyranos: 0.1.9

Since
  2008/11/05 (Oyranos: 0.1.9)

Date
  2009/04/13

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_Release(), oyOptions_Count(), and oyOptions_Get().

Referenced by oyConfig_s::oyConfig_Find(), oyConfig_s::oyConfig_Has(), oyDeviceSelectSimiliar(), oyFilterGraph_s::oyFilterGraph_PrepareContexts(), oyOptions_FindData(), oyOptions_FindDouble(), oyOptions_FindInt(), oyOptions_FindString(), oyOptions_MoveInStruct(), oyOptions_SetFromData(), oyOptions_SetFromDouble(), oyOptions_SetFromInt(), oyOptions_SetFromText(), oyObserver_s::oyStruct_DisableSignalSend(), oyObserver_s::oyStruct_EnableSignalSend(), and oyObserver_s::oyStruct_ObserverSignal().

int oyOptions_FindData | ( | oyOptions_s * | options,
|  | const char * | registration,
|  | oyPointer * | result,
|  | size_t * | size,
|  | oyAlloc_f | allocateFunc
| ) |  |

get a value

Function oyOptions_FindData

Parameters

  | options | the options list or set to manipulate
  | registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt" or simply a key, e.g. "my_opt"
  [out] | result | the data; With size == zero, the pointer is static and owned somewhere else. With size set, the pointer is owned my the caller.
  [out] | size | the data size
  [in] | allocateFunc | user allocator

Returns
  0 - option exists, is of correct type, holds a value; -1 - not found; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/11/07 (Oyranos: 0.1.10)

Date
  2009/11/07

References oyOBJECT_OPTION_S, oyOBJECT_OPTIONS_S, oyOption_s::oyOption_GetData(), oyOption_s::oyOption_Release(), oyOptions_Find(), and oyVAL_STRUCT.

int oyOptions_FindDouble | ( | oyOptions_s * | options,
|  | const char * | registration,
|  | int | pos,
|  | double * | result
| ) |  |

get a value

Function oyOptions_FindDouble

Parameters

  options | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt" or simple key, e.g. "my_opt"
  result | the double
  pos | the value position

Returns
  0 - option exists, is of correct type, holds a value at the position; -1 - not found; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/05/04 (Oyranos: 0.1.10)

Date
  2009/09/10

References oyOBJECT_OPTION_S, oyOBJECT_OPTIONS_S, oyOption_s::oyOption_GetValueDouble(), oyOption_s::oyOption_Release(), oyOptions_Find(), and oyVAL_DOUBLE.

int oyOptions_FindInt | ( | oyOptions_s * | options,
|  | const char * | registration,
|  | int | pos,
|  | int32_t * | result
| ) |  |

get a value

Function oyOptions_FindInt

Parameters

  options | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt" or simple key, e.g. "my_opt"
  pos | the values position in a possible list
  result | the integer

Returns
  0 - option exists, is of correct type, holds a value at the position; -1 - not found; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/05/04 (Oyranos: 0.1.10)

Date
  2009/05/04

References oyOBJECT_OPTION_S, oyOBJECT_OPTIONS_S, oyOption_s::oyOption_GetValueInt(), oyOption_s::oyOption_Release(), and oyOptions_Find().

Referenced by oyDeviceFromJSON(), and oyFilterPlug_s::oyFilterPlug_ResolveImage().

const char * oyOptions_FindString | ( | oyOptions_s * | options,
|  | const char * | registration,
|  | const char * | value
| ) |  |

search for a certain option key and possibly value

Function oyOptions_FindString

This function returns the first found value for a given key. The key is represented by the oyOption_s::name::nick The returned string is valid along the livetime of the particular option value.

Version
  Oyranos: 0.1.9

Since
  2008/10/07 (Oyranos: 0.1.8)

Date
  2009/04/13

References oyOBJECT_OPTION_S, oyOBJECT_OPTIONS_S, oyOption_s::oyOption_Release(), and oyOptions_Find().

Referenced by oyConfig_s::oyConfig_FindString(), oyConfigs_s::oyConfigs_FromDeviceClass(), oyConversion_s::oyConversion_RunPixels(), oyDeviceFromJSON(), oyDeviceGetInfo(), oyFilterGraph_s::oyFilterGraph_CountNodes(), oyFilterGraph_s::oyFilterGraph_GetNode(), oyProfile_s::oyProfile_AddDevice(), oyProfile_FromTaxiDB(), oyProfile_s::oyProfile_GetFileName(), and oyProfile_Install().

oyOptions_s * oyOptions_ForFilter | ( | const char * | registration,
|  | const char * | cmm,
|  | uint32_t | flags,
|  | oyObject_s | object
| ) |  |

provide Oyranos behaviour settings

     Function oyOptions_ForFilter

The returned options are read in from the Elektra settings and if thats not available from the inbuild defaults. The later can explicitely selected with oyOPTIONSOURCE_FILTER passed as flags argument. The key names map to the registration and XML syntax.

To obtain all advanced front end options from a meta module use:

    *  flags = oyOPTIONATTRIBUTE_ADVANCED |
    *          oyOPTIONATTRIBUTE_FRONT |
    *          OY_SELECT_COMMON

See Also
  OY_SELECT_FILTER OY_SELECT_COMMON oyOPTIONATTRIBUTE_e

Parameters

  [in] | registration | the filter registration to search for
  [in] | cmm | a CMM to match
  [in] | flags | for inbuild defaults | oyOPTIONSOURCE_FILTER; for options marked as advanced | oyOPTIONATTRIBUTE_ADVANCED | OY_SELECT_FILTER | OY_SELECT_COMMON
  | object | the optional object

Returns
  the options

Version
  Oyranos: 0.3.0

Since
  2008/10/08 (Oyranos: 0.1.8)

Date
  2011/01/29

References oyFilterCore_s::oyFilterCore_Release(), oyOBJECT_CMM_API4_S, and oyOptions_ForFilter_().

oyOptions_s * oyOptions_ForFilter_ | ( | oyFilterCore_s_ * | filter,
|  | uint32_t | flags,
|  | oyObject_s | object
| ) |  |

Provide Oyranos behaviour settings.

Function oyOptions_ForFilter_

References OY_SELECT_COMMON, OY_SELECT_FILTER, oyBOOLEAN_UNION, oyFILTER_REG_TYPE, oyOBJECT_CMM_API9_S, oyOption_s::oyOption_Release(), oyOptions_AppendOpts(), oyOptions_Count(), oyOptions_DoFilter(), oyOptions_FromBoolean(), oyOptions_FromText(), oyOptions_Get(), oyOptions_New(), oyOptions_Release(), and oyOPTIONSOURCE_FILTER.

Referenced by oyFilterNode_s::oyFilterNode_GetOptions(), and oyOptions_ForFilter().

oyOptions_s * oyOptions_FromBoolean | ( | oyOptions_s * | set_a,
|  | oyOptions_s * | set_b,
|  | oyBOOLEAN_e | type,
|  | oyObject_s | object
| ) |  |

boolean operations on two sets of option

Function oyOptions_FromBoolean

See Also
  oyOptions_Add

Parameters

  [in] | set_a | options set A
  [in] | set_b | options set B
  [in] | type | the operation to perform
  | object | the optional object

Version
  Oyranos: 0.1.8

Since
  2008/06/28 (Oyranos: 0.1.8)

Date
  2008/06/28

References oyBOOLEAN_DIFFERENZ, oyBOOLEAN_UNION, oyFILTER_REG_OPTION, oyOption_s::oyOption_Release(), oyOptions_Add(), oyOptions_Copy(), oyOptions_Count(), oyOptions_Get(), and oyOptions_New().

Referenced by oyOptions_ForFilter_().

oyOptions_s * oyOptions_FromText | ( | const char * | text,
|  | uint32_t | flags,
|  | oyObject_s | object
| ) |  |

deserialise a text file to oyOptions_s data

Function oyOptions_FromText

This function is based on libxml2.

Parameters

  [in] | text | the text to process
  [in] | flags | for future use
  | object | the optional object

Returns
  the data

Version
  Oyranos: 0.1.9

Since
  2008/11/17 (Oyranos: 0.1.9)

Date
  2008/11/17

References oyOptions_New().

Referenced by oyOptions_ForFilter_(), and oyOptions_SetDriverContext().

OYAPI oyOption_s *OYEXPORT oyOptions_Get | ( | oyOptions_s * | list,
|  | int | pos
| ) |  |

get a element of a Options list

Function oyOptions_Get

Parameters

  [in,out] | list | the list
  | pos | position

Version
  Oyranos: 0.1.10

Since
  2010/07/05 (Oyranos: 0.1.10)

Date
  2010/07/05

References oyOBJECT_OPTION_S, oyOBJECT_OPTIONS_S, and oyStructList_s::oyStructList_GetRefType().

Referenced by oyConfig_s::oyConfig_Compare(), oyConfig_s::oyConfig_EraseFromDB(), oyConfig_s::oyConfig_Get(), oyDeviceGetInfo(), oyDeviceProfileFromDB(), oyDeviceSetProfile(), oyOptions_Add(), oyOptions_AppendOpts(), oyOptions_CopyFrom(), oyOptions_CountType(), oyOptions_DoFilter(), oyOptions_Filter(), oyOptions_Find(), oyOptions_ForFilter_(), oyOptions_FromBoolean(), oyOptions_GetText(), oyOptions_GetType(), oyOptions_ObserversDisable(), oyOptions_ObserversEnable(), oyOptions_SaveToDB(), oyOptions_Set(), oyOptions_SetOpts(), and oyOptions_SetSource().

const char * oyOptions_GetText | ( | oyOptions_s * | options,
|  | oyNAME_e | type
| ) |  |

dump options to text

Function oyOptions_GetText

The type argument should select the following string in return:

- oyNAME_NAME - a readable XFORMS data model
- oyNAME_NICK - the hash ID
- oyNAME_DESCRIPTION - option registration name with key and without value

Todo:
  streamline output and group, avoid writing all levels for each key

Parameters

  [in,out] | options | the option
  | type | oyNAME_NICK is equal to an ID

Returns
  the text

Version
  Oyranos: 0.3.3

Since
  2008/11/25 (Oyranos: 0.1.9)

Date
  2011/10/31

References oyNAME_DESCRIPTION, oyNAME_NAME, oyOption_s::oyOption_GetText(), oyOption_s::oyOption_GetValueText(), oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyVAL_STRUCT.

Referenced by oyContextCollectData_(), and oyOption_s::oyOption_GetText().

oyStruct_s * oyOptions_GetType | ( | oyOptions_s * | options,
|  | int | pos,
|  | const char * | registration,
|  | oyOBJECT_e | type
| ) |  |

select from options with special attribute

Function oyOptions_GetType

Version
  Oyranos: 0.1.10

Since
  2009/03/04 (Oyranos: 0.1.10)

Date
  2009/03/04

References oyStruct_s::copy, oyOBJECT_OPTIONS_S, oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyVAL_STRUCT.

Referenced by oyImage_s::oyImage_CreateForDisplay().

OYAPI int OYEXPORT oyOptions_MoveIn | ( | oyOptions_s * | list,
|  | oyOption_s ** | obj,
|  | int | pos
| ) |  |

add an element to a Options list

Function oyOptions_MoveIn

Parameters

  [in] | list | list
  [in,out] | obj | list element
  | pos | position

Version
  Oyranos: 0.1.10

Since
  2010/07/05 (Oyranos: 0.1.10)

Date
  2010/07/05

References oyOBJECT_OPTION_S, oyOBJECT_OPTIONS_S, oyObserver_s::oyStruct_IsObserved(), oyObserver_s::oyStruct_ObserverAdd(), oyStructList_s::oyStructList_Create(), and oyStructList_s::oyStructList_MoveIn().

Referenced by oyOptions_Add(), oyOptions_AppendOpts(), oyOptions_CopyFrom(), oyOptions_DoFilter(), oyOptions_MoveInStruct(), oyOptions_Set(), oyOptions_SetDriverContext(), oyOptions_SetFromData(), oyOptions_SetFromDouble(), oyOptions_SetFromInt(), and oyOptions_SetFromText().

int oyOptions_MoveInStruct | ( | oyOptions_s ** | obj,
|  | const char * | registration,
|  | oyStruct_s ** | oy_struct,
|  | uint32_t | flags
| ) |  |

change a value

Function oyOptions_MoveInStruct

Parameters

  obj | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt"
  oy_struct | the Oyranos style object to move in
  flags | can be OY_CREATE_NEW for a new option, or OY_ADD_ALWAYS

Version
  Oyranos: 0.1.10

Since
  2009/03/05 (Oyranos: 0.1.10)

Date
  2009/03/05

Add a new option if the OY_CREATE_NEW flag is present.

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_FromRegistration(), oyOption_s::oyOption_Release(), oyOption_s::oyOption_StructMoveIn(), oyOptions_Find(), oyOptions_MoveIn(), and oyOptions_New().

Referenced by oyImage_s::oyImage_Create().

OYAPI oyOptions_s *OYEXPORT oyOptions_New | ( | oyObject_s | object | ) |

allocate a new Options object

Function oyOptions_New

References oyOBJECT_OBJECT_S.

Referenced by oyConfig_s::oyConfig_ClearDBData(), oyConfig_s::oyConfig_Count(), oyConfig_s::oyConfig_Get(), oyConfig_s::oyConfig_GetOptions(), oyConfig_s::oyConfig_SaveToDB(), oyDeviceAskProfile2(), oyDeviceBackendCall(), oyDeviceGet(), oyDeviceGetInfo(), oyDeviceSetup(), oyDevicesGet(), oyFilterNode_s::oyFilterNode_GetOptions(), oyFilterNode_s::oyFilterNode_GetTags(), oyOptions_CopyFrom(), oyOptions_DoFilter(), oyOptions_Filter(), oyOptions_ForFilter_(), oyOptions_FromBoolean(), oyOptions_FromText(), oyOptions_MoveInStruct(), oyOptions_SetDriverContext(), oyOptions_SetFromData(), oyOptions_SetFromDouble(), oyOptions_SetFromInt(), and oyOptions_SetFromText().

OYAPI int OYEXPORT oyOptions_ObserverAdd | ( | oyOptions_s * | object,
|  | oyStruct_s * | observer,
|  | oyStruct_s * | user_data,
|  | oyObserver_Signal_f | signalFunc
| ) |  |

observe options and its elements

Function oyOptions_ObserverAdd

Parameters

  [in] | object | the options
  [in] | observer | the in observation intereressted object
  [in] | user_data | additional static informations
  [in] | signalFunc | the signal handler

Returns
  0 - fine; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/10/28 (Oyranos: 0.1.10)

Date
  2009/10/28

References oyObserver_s::oyStruct_ObserverAdd(), and oyStructList_s::oyStructList_ObserverAdd().

Referenced by oyFilterNode_s::oyFilterNode_GetOptions().

OYAPI int OYEXPORT oyOptions_ObserversDisable | ( | oyOptions_s * | object | ) |

disable signaling

Function oyOptions_ObserversDisable

Parameters

  [in] | object | the options

Returns
  0 - fine; 1 - error

Version
  Oyranos: 0.1.10

Since
  2010/04/07 (Oyranos: 0.1.10)

Date
  2010/04/07

References oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyObserver_s::oyStruct_DisableSignalSend().

OYAPI int OYEXPORT oyOptions_ObserversEnable | ( | oyOptions_s * | object | ) |

disable signaling

Function oyOptions_ObserversEnable

Parameters

  [in] | object | the options

Returns
  0 - fine; 1 - error

Version
  Oyranos: 0.1.10

Since
  2010/04/07 (Oyranos: 0.1.10)

Date
  2010/04/07

References oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyObserver_s::oyStruct_EnableSignalSend().

OYAPI int OYEXPORT oyOptions_Release | ( | oyOptions_s ** | options | ) |

release and possibly deallocate a oyOptions_s object

Function oyOptions_Release

Parameters

  [in,out] | options | Options struct object

References oyOBJECT_OPTIONS_S.

Referenced by oyConfig_s::oyConfig_ClearDBData(), oyConfig_s::oyConfig_Count(), oyConfig_s::oyConfig_Get(), oyConfig_s::oyConfig_GetBestMatchFromTaxiDB(), oyConfig_s::oyConfig_GetFromDB(), oyConfig_s::oyConfig_SaveToDB(), oyConfigs_s::oyConfigs_FromDeviceClass(), oyConversion_CreateFromImage(), oyDeviceAskProfile2(), oyDeviceBackendCall(), oyDeviceGetInfo(), oyDeviceProfileFromDB(), oyDeviceSelectSimiliar(), oyDeviceSetProfile(), oyDeviceSetup(), oyDevicesFromTaxiDB(), oyDeviceUnset(), oyFilterNode_s::oyFilterNode_GetUi(), oyFilterPlug_s::oyFilterPlug_ResolveImage(), oyImage_FromFile(), oyImage_s::oyImage_SetCritical(), oyImage_ToFile(), oyOptions_CopyFrom(), oyOptions_DoFilter(), oyOptions_ForFilter_(), and oyOptions_SetDriverContext().

OYAPI int OYEXPORT oyOptions_ReleaseAt | ( | oyOptions_s * | list,
|  | int | pos
| ) |  |

release a element from a Options list

Function oyOptions_ReleaseAt

Parameters

  [in,out] | list | the list
  | pos | position

Version
  Oyranos: 0.1.10

Since
  2010/07/05 (Oyranos: 0.1.10)

Date
  2010/07/05

References oyOBJECT_OPTIONS_S, oyStructList_s::oyStructList_GetParentObjType(), and oyStructList_s::oyStructList_ReleaseAt().

OYAPI int OYEXPORT oyOptions_SaveToDB | ( | oyOptions_s * | options,
|  | const char * | registration,
|  | char ** | new_reg,
|  | oyAlloc_f | allocateFunc
| ) |  |

store a oyOptions_s in DB

Function oyOptions_SaveToDB

Parameters

  [in] | options | the options
  [in] | registration | the registration
  [out] | new_reg | the new registration; optional
  [in] | alloc | the user allocator for new_reg; optional

Returns
  0 - good, 1 >= error

Version
  Oyranos: 0.3.0

Since
  2009/02/08 (Oyranos: 0.1.10)

Date
  2011/01/29

References oyOBJECT_BLOB_S, oyOption_s::oyOption_GetRegistration(), oyOption_s::oyOption_GetValueString(), oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyVAL_STRUCT.

Referenced by oyConfig_s::oyConfig_SaveToDB().

int oyOptions_Set | ( | oyOptions_s * | options,
|  | oyOption_s * | option,
|  | int | pos,
|  | oyObject_s | object
| ) |  |

set a element in a Options list

Function oyOptions_Set

Already listed options are replaced by the new option. A option new to the existing set will be referenced if no object argument is given.

Adding a new element without any checks is as simple as following code:

    *     tmp = oyOption_Copy( option, object );
    *     oyOptions_MoveIn( options, &tmp, -1 );

Version
  Oyranos: 0.1.10

Since
  2009/10/25 (Oyranos: 0.1.10)

Date
  2009/10/25

References oyOption_s::oyOption_Copy(), oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyOptions_MoveIn().

Referenced by oyDeviceSetup(), and oyOptions_SetOpts().

OYAPI int OYEXPORT oyOptions_SetDriverContext | ( | oyOptions_s ** | options,
|  | oyPointer | driver_context,
|  | const char * | driver_context_type,
|  | size_t | driver_context_size,
|  | oyObject_s | object
| ) |  |

set a device option from a given external context

Function oyOptions_SetDriverContext

The options will be created in case they do not exist. The driver_context_type accepts "xml". The data in driver_context will be converted to a options set following the Oyranos options XML schemes with the help oyOptions_FromText(). Any other pointer will be converted to a oyBlob_s object. The name of that object will come from driver_context_type.

Parameters

  [in,out] | options | options for the device
  [in] | driver_context | driver context
  [in] | driver_context_type | "xml" or something related to the driver
  [in] | driver_context_size | size of driver_context
  [in] | object | a optional object

Returns
  1 - error; 0 - success; -1 - otherwise

Version
  Oyranos: 0.1.10

Since
  2009/05/18 (Oyranos: 0.1.10)

Date
  2009/05/18

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_FromRegistration(), oyOption_s::oyOption_SetFromData(), oyOption_s::oyOption_StructMoveIn(), oyOptions_FromText(), oyOptions_MoveIn(), oyOptions_New(), and oyOptions_Release().

int oyOptions_SetFromData | ( | oyOptions_s ** | options,
|  | const char * | registration,
|  | oyPointer | ptr,
|  | size_t | size,
|  | uint32_t | flags
| ) |  |

set a data blob or plain pointer

Function oyOptions_SetFromData

Parameters

  options | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt"
  ptr | the pointer
  size | the pointer size
  flags | can be OY_CREATE_NEW for a new option, or OY_ADD_ALWAYS

Returns
  0 - success; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/11/07 (Oyranos: 0.1.10)

Date
  2009/11/07

Add a new option if the OY_CREATE_NEW flag is present.

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_FromRegistration(), oyOption_s::oyOption_Release(), oyOption_s::oyOption_SetFromData(), oyOptions_Find(), oyOptions_MoveIn(), and oyOptions_New().

int oyOptions_SetFromDouble | ( | oyOptions_s ** | obj,
|  | const char * | registration,
|  | double | value,
|  | int | pos,
|  | uint32_t | flags
| ) |  |

change a value

Function oyOptions_SetFromDouble

Parameters

  obj | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt"
  value | the value to set
  pos | the position in a value list
  flags | can be OY_CREATE_NEW for a new option, OY_STRING_LIST or OY_ADD_ALWAYS

Returns
  0 - success; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/05/04 (Oyranos: 0.1.10)

Date
  2009/09/10

Add a new option if the OY_CREATE_NEW flag is present.

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_FromRegistration(), oyOption_s::oyOption_Release(), oyOption_s::oyOption_SetFromDouble(), oyOptions_Find(), oyOptions_MoveIn(), and oyOptions_New().

int oyOptions_SetFromInt | ( | oyOptions_s ** | obj,
|  | const char * | registration,
|  | int32_t | value,
|  | int | pos,
|  | uint32_t | flags
| ) |  |

change a value

Function oyOptions_SetFromInt

Parameters

  obj | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt"
  value | the value to set
  pos | the position in a value list
  flags | can be OY_CREATE_NEW for a new option, OY_STRING_LIST or OY_ADD_ALWAYS

Returns
  0 - success; 1 - error

Version
  Oyranos: 0.1.10

Since
  2009/05/04 (Oyranos: 0.1.10)

Date
  2009/05/04

Add a new option if the OY_CREATE_NEW flag is present.

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_FromRegistration(), oyOption_s::oyOption_Release(), oyOption_s::oyOption_SetFromInt(), oyOptions_Find(), oyOptions_MoveIn(), and oyOptions_New().

Referenced by oyDevicesFromTaxiDB().

int oyOptions_SetFromText | ( | oyOptions_s ** | obj,
|  | const char * | registration,
|  | const char * | value,
|  | uint32_t | flags
| ) |  |

change a value

Function oyOptions_SetFromText

Parameters

  obj | the options list or set to manipulate
  registration | the options registration name, e.g. "org/my_org/openicc/my_app/my_opt"
  value | the value to set
  flags | can be OY_CREATE_NEW for a new option, OY_STRING_LIST or OY_ADD_ALWAYS

Version
  Oyranos: 0.3.0

Since
  2008/11/27 (Oyranos: 0.1.9)

Date
  2011/03/15

Add a new option if the OY_CREATE_NEW flag is present.

Flags are passed on to oyOption_SetFromText, e.g. OY_STRING_LIST.

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_FromRegistration(), oyOption_s::oyOption_Release(), oyOption_s::oyOption_SetFromText(), oyOptions_Find(), oyOptions_MoveIn(), and oyOptions_New().

Referenced by oyConfig_s::oyConfig_AddDBData(), oyDeviceGetInfo(), oyDeviceProfileFromDB(), oyDeviceSelectSimiliar(), oyDeviceSetProfile(), oyDeviceSetup(), oyDevicesFromTaxiDB(), oyDeviceUnset(), oyImage_s::oyImage_CreateForDisplay(), oyImage_FromFile(), oyImage_ToFile(), and oyProfile_s::oyProfile_GetFileName().

int oyOptions_SetOpts | ( | oyOptions_s * | list,
|  | oyOptions_s * | add
| ) |  |

set options in a Options list

Function oyOptions_SetOpts

Already listed options are replaced by the new options.

See Also
  oyOptions_Set It will use copying.

Version
  Oyranos: 0.1.10

Since
  2009/10/25 (Oyranos: 0.1.10)

Date
  2009/10/25

References oyOption_s::oyOption_Release(), oyOptions_Count(), oyOptions_Get(), and oyOptions_Set().

Referenced by oyOptions_CopyFrom().

int oyOptions_SetSource | ( | oyOptions_s * | options,
|  | oyOPTIONSOURCE_e | source
| ) |  |

set source attribute

Function oyOptions_SetSource

Parameters

  options | the options list or set to manipulate
  source | the options new source attribute

Version
  Oyranos: 0.1.10

Since
  2009/01/27 (Oyranos: 0.1.9)

Date
  2009/01/27

References oyOBJECT_OPTIONS_S, oyOption_s::oyOption_Release(), oyOptions_Count(), and oyOptions_Get().

Referenced by oyConfigs_s::oyConfigs_FromDomain(), and oyProfile_s::oyProfile_GetDevice().

OYAPI int OYEXPORT oyOptions_Sort | ( | oyOptions_s * | list,
|  | int32_t * | rank_list
| ) |  |

sort a list according to a rank_list

Function oyOptions_Sort

Version
  Oyranos: 0.3.0

Since
  2011/02/01 (Oyranos: 0.3.0)

Date
  2011/02/01

References oyOBJECT_OPTIONS_S, and oyStructList_s::oyStructList_Sort().

## Field Documentation

oyStruct_Copy_f oyOptions_s::copy

copy function

oyStruct_Release_f oyOptions_s::release

release function